﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Calculator;

namespace CalcTest2
{
    [TestClass]
    public class UnitTest1
    {
        //Простые тесты
        [TestMethod]
        public void SumTest()
        {
            double result = MainWindow.Plus(2, 2);
            Assert.AreEqual(4, result);
        }
        [TestMethod]
        public void DiffTest()
        {
            double result = MainWindow.Minus(5, 2);
            Assert.AreNotEqual(2, result);
        }
        [TestMethod]
        public void MultTest()
        {
            double result = MainWindow.Multiply(5, 5);
            bool flag = true;
            if (result == 25)
            {
                flag = true;
            }
            else
            {
                flag = false;
            }
            Assert.IsTrue(flag);
        }
        [TestMethod]
        public void DivTest()
        {
            double result = MainWindow.Divide(9, 3);
            bool flag = false;
            if (result == 3)
            {
                flag = false;
            }
            else
            {
                flag = true;
            }
            Assert.IsFalse(flag);
        }
        [TestMethod]
        public void PowerTest()
        {
            double result = MainWindow.Power(2, 3);
            Assert.IsInstanceOfType(result, typeof(double));
        }
        [TestMethod]
        public void RootTest()
        {
            double result = MainWindow.Root(9);
            Assert.IsNotInstanceOfType(result, typeof(int));
        }
        [TestMethod]
        public void PercentTest()
        {
            double result = MainWindow.Percent(100, 5);
            Assert.IsNotNull(result);
        }
        [TestMethod]
        public void Log()
        {
            double result = MainWindow.Percent(100, 5);
            Assert.AreEqual(5, result);
        }
        [TestMethod]
        public void PlusMinusTest()
        {
            double result1 = MainWindow.Plus(20, 5);
            double result2 = MainWindow.Minus(30, 5);
            Assert.AreEqual(result2, result1);
        }
        [TestMethod]
        public void DivMultTest()
        {
            double result1 = MainWindow.Multiply(3, 3);
            double result2 = MainWindow.Divide(27, 9);
            Assert.AreNotEqual(result2, result1);
        }
        //Сложные тесты
        [TestMethod]
        public void ExPlusMethod()
        {
            Assert.ThrowsException<AssertFailedException>(() => Assert.ThrowsException<SystemException>(() => MainWindow.Plus(Convert.ToInt32("a"), 5)));
        }
        [TestMethod]
        public void ExMinusMethod()
        {
            Assert.ThrowsException<AssertFailedException>(() => Assert.ThrowsException<SystemException>(() => MainWindow.Minus(Convert.ToInt32("a"), 5)));
        }
        [TestMethod]
        public void ExDivMethod()
        {
            Assert.ThrowsException<AssertFailedException>(() => Assert.ThrowsException<SystemException>(() => MainWindow.Divide(Convert.ToInt32("a"), 5)));
        }
        [TestMethod]
        public void ExRootMethod()
        {
            Assert.ThrowsException<AssertFailedException>(() => Assert.ThrowsException<SystemException>(() => MainWindow.Root(Convert.ToInt32("a"))));
        }
        [TestMethod]
        public void ExSinMethod()
        {
            Assert.ThrowsException<AssertFailedException>(() => Assert.ThrowsException<SystemException>(() => MainWindow.Sin(Convert.ToInt32("a"))));
        }
    }
}
